<template>
  <div v-if="isViewStyleGrid" class="grid">
    <Product v-for="(product, i) in products" :key="i" :product="product" />
  </div>
  <div v-else class="list">
    <div v-for="(product, i) in products" :key="i">
      <Product :product="product" :gridViewStyle="false"></Product>
      <div class="seperator" v-if="i !== products.length - 1"></div>
    </div>
  </div>
</template>

<script>
import Product from "@/components/catalog/Product";

export default {
  name: "ProductList",
  data() {
    return {
      screenWidth: 1000 // something bigger than 750px. doesnt matter will update automatically!
    }
  },
  components: {
    Product
  },
  props: {
    products: {
      type: Array,
      required: true
    }
  },
  computed: {
    isViewStyleGrid() {
      if (this.screenWidth <= 750) {
        return false;
      }
      return this.$store.getters['shop/getViewStyle'] === "grid";
    }
  },
  methods: {
    onResize() {
      this.screenWidth = window.innerWidth;
    }
  },
  mounted() {
    this.screenWidth = window.innerWidth;
    window.addEventListener('resize', this.onResize);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.onResize);
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables'

.grid
  display grid
  justify-content right
  grid-gap $md
  grid-template-columns repeat(auto-fit, minmax($product-list-column-min-width, max-content))

.list
  width 100%

.seperator
  margin $md 0
  margin-right $product-listed-thumbnail-size
  width (100% - $product-listed-thumbnail-size)
  height 1px
  background-color rgba($white, .2)
  @media only screen and (max-width: 1200px)
    margin-right 0
    width 100%
</style>
